#pragma once
#include "interfaces.h"
#include "defs.h"


#define		MAX_STRING_LEN		1024
// vertex buffer size - each character requires 4 bytes
const FONTVBSIZE = 4*MAX_STRING_LEN;
const FONTIBSIZE = 6*MAX_STRING_LEN;

class X3DFont :	public I3DFont
{
private:
	DWORD						m_dwRef;
	LPDIRECT3D8					d3d;
	LPDIRECT3DDEVICE8			m_d3dDevice;
	ITexture					*m_texFont;
	IVertexBuffer				*m_pVB;
	IIndexBuffer				*m_pIB;
	FONT_VERTEX					*v;
		
	int	bmWidth, bmHeight;
	int cellWidth, cellHeight;
	char charWidths[256];	

	long numChars;
	bool begun;

public:
	X3DFont(LPDIRECT3D8 pd3d, LPDIRECT3DDEVICE8 pd3dDevice);
	~X3DFont();

	virtual HRESULT DrawText(const char* text, int x, int y, DWORD color);
	virtual HRESULT DrawTextEx(const char* text, int x, int y, DWORD colorTop, DWORD colorBottom, float scale);
	virtual HRESULT Load(BitmapFontLoadEnum filetype, char* fn);
	virtual HRESULT BeginDraw();
	virtual HRESULT EndDraw();
	virtual RECT GetTextRectEx(const char* text, int x, int y, float scale);
	virtual RECT GetTextRect(const char* text, int x, int y);

	virtual HRESULT		AddRef();
	virtual HRESULT		Release();

private:
	D3DFORMAT GetBestFormat();
};
