#pragma once

class XTexture : public ITexture
{
	DWORD					m_dwID;
	LPDIRECT3DTEXTURE8		m_lpTexture;	
	// information for restoring
	char					m_szFilePath[MAX_PATH];
	LPDIRECT3DDEVICE8		m_lpDevice;
	int						m_iMipLevels;
	D3DFORMAT				m_formatTextureFormat;
	// real dim of the created texture
	int						m_iWidth;
	int						m_iHeight;
	// references
	DWORD					m_dwRef;
	BOOL					m_bSharedTexture;

public:
	virtual int						LoadTextureFromFile(LPCSTR szFileName);
	virtual int						LoadTextureFromFileEx(LPCSTR szFileName, int iMipLevels, D3DFORMAT formatTextureFormat, D3DPOOL d3dPool = D3DPOOL_MANAGED);
	virtual int						Restore();
	virtual int						ReleaseResource();
	virtual LPDIRECT3DTEXTURE8		GetTexture() { return m_lpTexture; }
	virtual LPDIRECT3DDEVICE8		GetDevice() {return m_lpDevice; }
	virtual D3DFORMAT				GetFormat() { return m_formatTextureFormat;}
	virtual int						Width() {return m_iWidth;}
	virtual int						Height() {return m_iHeight;}
	virtual void					SetID(DWORD dwID) {m_dwID = dwID;}
	virtual DWORD					GetID() {return m_dwID;}
	virtual char*					GetTexturePath() {return m_szFilePath;}
	virtual RES_TYPE				GetType() {return Texture;}
	virtual	BOOL					operator==(IResource &pRes);
	// interface functions
	virtual HRESULT					AddRef();
	virtual HRESULT					Release();
public:
	XTexture(void);
	~XTexture(void);
};
