#ifndef CDYNZASOB_H
  #define CDYNZASOB_H

  template<class T> class CPrvek {
		private:
			T m_Data;
			CPrvek<T> *m_lpDalsi;
		public:
			CPrvek() : m_lpDalsi(NULL) { }
			CPrvek(const T& _Data) : m_Data(_Data), m_lpDalsi(NULL) { }

			T VratData() const { return m_Data; }
			CPrvek<T>* VratDalsi() const { return m_lpDalsi; }
			void NastavDalsi(CPrvek<T> *_lpDalsi) { m_lpDalsi = _lpDalsi; }
			void NastavData(const T& _Data) { m_Data = _Data; }
  };

  template<class T> class CDynZasob {
		private:
			CPrvek<T> *m_lpVrchol;
		public:
			CDynZasob() : m_lpVrchol(NULL) { }
			~CDynZasob() { if(!JePrazdny()) { SmazZasob(); } }

			void VytvorPrazdny();

			bool SmazZasob();

			bool JePrazdny() { return (m_lpVrchol == NULL); }

			bool Vloz(const T& _Data);	// vklada na zacatek seznamu
			bool Vyjmi(T &_Vyber);	// odebere prvni prvek
  };

  template<class T> void CDynZasob<T>::VytvorPrazdny()
  {
	  if(m_lpVrchol)
	  {
		  SmazZasob();
	  }
	  
	  m_lpVrchol = NULL;
  }

  template<class T> bool CDynZasob<T>::SmazZasob()
  {
	  bool bNavrat = false;

	  if(!JePrazdny())
	  {
		  CPrvek<T> *lpMazany;
		  
		  while(m_lpVrchol)
		  {
			  lpMazany = m_lpVrchol;
			  m_lpVrchol = m_lpVrchol->VratDalsi();	// posun na dalsi prvek
			  delete lpMazany;
		  }

		  bNavrat = true;
	  }

	  return bNavrat;
  }

  template<class T> bool CDynZasob<T>::Vloz(const T& _Data)
  {
	  bool bNavrat = false;

	  // jen vlozime prvek do zasobniku
	  CPrvek<T> *lpNovy = new CPrvek<T>(_Data);

	  if(lpNovy)
	  {
		  lpNovy->NastavDalsi(m_lpVrchol);	// novy prvek bude ukazovat na puvodni zacatek

		  m_lpVrchol = lpNovy;	// a presuneme novy zacatek

		  bNavrat = true;
	  }

	  // opet novy prvek nemazeme
	
	  return bNavrat;
  }

  template<class T> bool CDynZasob<T>::Vyjmi(T &_Vyber)
  {
	  bool bNavrat = false;

	  if(!JePrazdny())
	  {
		  _Vyber = m_lpVrchol->VratData();

		  CPrvek<T> *lpMazany = m_lpVrchol;
		  m_lpVrchol = m_lpVrchol->VratDalsi();

		  delete lpMazany;

		  bNavrat = true;
	  }

	  return bNavrat;
  }
  
#endif
